﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/messages_cap.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.load("soccer_mod_2010/cap/fights")

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap.ini")

	popup = popuplib.create("sm_popup_admin_cap")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("spectator"))
	popup.addline(line)

	line = "->2. %s" % (text("fights"))
	popup.addline(line)

	line = "->3. %s" % (text("random_player"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, spec_all)
	popup.submenu(2, "sm_popup_admin_cap_fights")
	popup.select(3, random_player)
	popup.submenu(4, "sm_popup_admin_cap")
	popup.submenu(5, "sm_popup_admin_cap")
	popup.submenu(6, "sm_popup_admin_cap")
	popup.submenu(7, "sm_popup_admin_cap")
	popup.submenu(8, "sm_popup_admin_cap")
	popup.submenu(9, "sm_popup_admin")

# ******************** Popup choices ********************
def spec_all(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("cap_fight")
		if check == 0:
			lang_msg("cap_start", tokens, 1)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				if ply.team > 1:
					cmd = "es_changeteam %s 1" % (ply.userid)
					es.server.queuecmd(cmd)

				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, messages("cap_start", tokens, ply.get("lang")))
				es.server.queuecmd(cmd)

			name = es.getplayername(userid)
			tokens = {}
			tokens["name"] = name
			lang_msg("spec", tokens, 0)
		else:
			es.tell(userid, "#green", messages("no_spec_fight", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_spec_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

def random_player(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("cap_fight")
	if check == 0:
		check = es.ServerVar("match")
		if check == 0:
			ts = int(es.getplayercount(2))
			cts = int(es.getplayercount(3))

			if ts == cts:
				force_random_player(userid, 2)
			elif ts < cts:
				force_random_player(userid, 2)
			elif ts > cts:
				force_random_player(userid, 3)
		else:
			es.tell(userid, "#green", messages("no_random_player_match", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_random_player_fight", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

# ******************** Functions ********************
def lang_msg(text, tokens, center, team = None):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		if team != None:
			tokens["team"] = messages(team, tokens, player.get("lang"))
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def force_random_player(userid, team):
	tokens = {}
	player = playerlib.getPlayer(userid)
	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		cmd = "es_changeteam %s %s" % (myPlayerList[number], team)
		es.server.queuecmd(cmd)

		name = es.getplayername(userid)
		target = es.getplayername(myPlayerList[number])
		tokens["name"] = name
		tokens["target"] = target
		lang_msg("random_player", tokens, 0)
	else:
		es.tell(userid, "#green", messages("no_player_available", tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_cap")

	es.unload("soccer_mod_2010/cap/fights")