﻿import es
import langlib
import playerlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.load("soccer_mod_2010/info/commands")
	es.load("soccer_mod_2010/info/credits")
	es.load("soccer_mod_2010/info/help")
	es.load("soccer_mod_2010/info/leagues")
	es.load("soccer_mod_2010/info/server")
	es.load("soccer_mod_2010/info/version")

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/info/popup_info.ini")

	popup = popuplib.create("sm_popup_info")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("commands"))
	popup.addline(line)

	line = "->2. %s" % (text("help"))
	popup.addline(line)

	line = "->3. %s" % (text("server"))
	popup.addline(line)

	line = "->4. %s" % (text("leagues"))
	popup.addline(line)

	line = "->5. %s" % (text("version"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("credits"))
	popup.addline(line)

	popup.addline(" ")

	line = "0. %s" % (common("close"))
	popup.addline(line)

	popup.submenu(1, "sm_popup_info_commands")
	popup.submenu(2, "sm_popup_info_help")
	popup.submenu(3, "sm_popup_info_server")
	popup.submenu(4, "sm_popup_info_leagues")
	popup.submenu(5, "sm_popup_info_version")
	popup.submenu(6, "sm_popup_info_translations")
	popup.submenu(7, "sm_popup_info")
	popup.submenu(8, "sm_popup_info")
	popup.submenu(9, "sm_popup_info_credits")

# ******************** Commands ********************
def cmd_info():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		popuplib.send("sm_popup_info", userid)
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_info")

	es.unload("soccer_mod_2010/info/commands")
	es.unload("soccer_mod_2010/info/credits")
	es.unload("soccer_mod_2010/info/help")
	es.unload("soccer_mod_2010/info/leagues")
	es.unload("soccer_mod_2010/info/server")
	es.unload("soccer_mod_2010/info/version")