﻿import es
import gamethread
import langlib
import playerlib
import random
import re
from spe.games import cstrike

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/player/messages.ini")

# ******************** Load ********************
def load():
	global round_end
	round_end = 0

	global players
	players = []

# ******************** Events ********************
def player_death(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		delay = es.ServerVar("sm_player_respawn_length")
		gamethread.delayed(delay, respawn, (event_var['userid']))

def player_disconnect(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		global players
		if event_var["es_steamid"] in players:
			players.remove(event_var["es_steamid"])

def player_hurt(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 0:
			enabled = es.ServerVar("sm_player_god_mode_on")
			if enabled == 0:
				player = playerlib.getPlayer(event_var["userid"])
				player.health = 250

		check = es.ServerVar("sm_player_hurt_sounds_on")
		if check == 1:
			length = len(hurt_sounds) - 1
			sound = random.randint(0, length)
			es.emitsound("player", event_var["userid"], hurt_sounds[sound], "1.0", "1.0")

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		player = playerlib.getPlayer(event_var["userid"])
		if player.team > 1:
			check = es.ServerVar("cap_fight")
			if check == 0:
				player.health = 250

				check = es.ServerVar("sm_player_god_mode_on")
				if check == 1:
					player.godmode(1)

			global players
			if player.steamid not in players:
				set_skin(event_var["userid"], 0)
			else:
				set_skin(event_var["userid"], 1)

def player_team(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		delay = es.ServerVar("sm_player_respawn_length")
		gamethread.delayed(delay, respawn, (event_var['userid']))

def round_start(event_var):
	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		global round_end
		round_end = 0

		players = es.getUseridList()
		length = len(players)
		if length > 0:
			length -= 1
			value = random.randint(0, length)
			userid = players[value]

			cmd = 'es_xfire %s trigger_hurt addoutput "OnStartTouch point_servercommand,command,es_xdoblock soccer_mod_2010/player/disable_god_mode"' % (userid)
			es.server.queuecmd(cmd)

def round_end(event_var):
	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		global round_end
		round_end = 1

# ******************** Command goalkeeper ********************
def cmd_gk():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		global players
		if player.steamid not in players:
			players.append(player.steamid)

			es.tell(userid, "#green", messages("gk", tokens, player.get("lang")))

			set_skin(userid, 1)
		else:
			players.remove(player.steamid)

			es.tell(userid, "#green", messages("no_gk", tokens, player.get("lang")))

			set_skin(userid, 0)
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def disable_god_mode():
	myPlayerList = playerlib.getPlayerList("#alive")
	for ply in myPlayerList:
		ply.godmode(0)

def set_skin(userid, gk):
	player = playerlib.getPlayer(userid)
	if player.team > 1:
		if player.team == 2:
			if gk == 0:
				model = es.ServerVar("sm_player_model_t")
				cmd = "playerset model %s %s" % (userid, model)
				es.server.queuecmd(cmd)
			else:
				model = es.ServerVar("sm_player_model_t_gk")
				cmd = "playerset model %s %s" % (userid, model)
				es.server.queuecmd(cmd)
		elif player.team == 3:
			if gk == 0:
				model = es.ServerVar("sm_player_model_ct")
				cmd = "playerset model %s %s" % (userid, model)
				es.server.queuecmd(cmd)
			else:
				model = es.ServerVar("sm_player_model_ct_gk")
				cmd = "playerset model %s %s" % (userid, model)
				es.server.queuecmd(cmd)

def respawn(userid):
	exists = es.exists("userid", userid)
	if exists == 1:
		player = playerlib.getPlayer(userid)
		if player.isdead == 1 and player.team > 1:
			global round_end
			if round_end == 0:
				cstrike.respawn(userid)