﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/messages_referee_punish.ini")

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

cheer_leaders = []

# ******************** Load ********************
def load():
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	delete_keygroup()

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		if event_var["es_steamid"] in cheer_leaders:
			es.give(event_var['userid'], "player_weaponstrip")
			es.fire(event_var['userid'], "player_weaponstrip", "strip")

			cmd = "playerset color %s 255 255 255 150" % (event_var["userid"])
			es.server.queuecmd(cmd)

			es.setplayerprop(event_var["userid"], "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_say(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		team = int(event_var["es_userteam"])
		if team > 1:
			if event_var["es_steamid"] in cheer_leaders:
				number = random.randint(1, 3)
				value = "sm_referee_sound_cheer_leader_%s" % (number)
				sound = es.ServerVar(value)
				player_sound(event_var["userid"], sound, 1, 0.5)

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/popup_admin_referee_punish.ini")

	popup = popuplib.create("sm_popup_admin_referee_punish")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("fireworks"))
	popup.addline(line)

	line = "->2. %s" % (text("give_dope"))
	popup.addline(line)

	line = "->3. %s" % (text("out_breath"))
	popup.addline(line)

	line = "->4. %s" % (text("lightning"))
	popup.addline(line)

	line = "->5. %s" % (text("cheer_leader"))
	popup.addline(line)

	line = "->6. %s" % (text("clear_cheer_leader"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, select_punishment)
	popup.select(2, select_punishment)
	popup.select(3, select_punishment)
	popup.select(4, select_punishment)
	popup.select(5, select_punishment)
	popup.select(6, popup_clear_cheer_leaders)
	popup.submenu(7, "sm_popup_admin_referee_punish")
	popup.submenu(8, "sm_popup_admin_referee_punish")
	popup.submenu(9, "sm_popup_admin_referee")

# ******************** Popup choices ********************
def select_punishment(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	myPlayerList = playerlib.getPlayerList("#human,#alive")
	length = len(myPlayerList)
	if length > 0:
		if choice == 1:
			create_player_menu(name, messages("select_player"), "#alive", "sm_popup_admin_referee_punish", "fireworks")
		elif choice == 2:
			create_player_menu(name, messages("select_player"), "#alive", "sm_popup_admin_referee_punish", "give_dope")
		elif choice == 3:
			create_player_menu(name, messages("select_player"), "#alive", "sm_popup_admin_referee_punish", "out_breath")
		elif choice == 4:
			create_player_menu(name, messages("select_player"), "#alive", "sm_popup_admin_referee_punish", "lightning")
		elif choice == 5:
			create_player_menu(name, messages("select_player"), "#alive", "sm_popup_admin_referee_punish", "cheer_leader")
		popuplib.send(name, userid)
	else:
		es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_referee_punish", userid)

def popup_clear_cheer_leaders(userid, choice, popupid):
	delete_keygroup()

	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name
	lang_msg("cleared_cheer_leaders", tokens)

	popuplib.send("sm_popup_admin_referee_punish", userid)

# ******************** Player selection choices ********************
def fireworks(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		target = playerlib.getPlayer(choice)
		if target.isdead == 0:
			sound = es.ServerVar("sm_referee_sound_fireworks")
			player_sound(choice, sound, 1, 0.5)

			player_shake(choice, 2, 100)

			push_player(choice, 5)
			gamethread.delayed(0.1, push_player, (choice, 20))
			gamethread.delayed(0.2, push_player, (choice, 45))
			gamethread.delayed(0.3, push_player, (choice, 80))
			gamethread.delayed(0.4, push_player, (choice, 125))
			gamethread.delayed(0.5, push_player, (choice, 180))
			gamethread.delayed(0.6, push_player, (choice, 245))
			gamethread.delayed(0.7, push_player, (choice, 320))
			gamethread.delayed(0.8, push_player, (choice, 405))
			gamethread.delayed(0.9, push_player, (choice, 500))
			gamethread.delayed(1, push_player, (choice, 605))
			gamethread.delayed(1.1, push_player, (choice, 720))
			gamethread.delayed(1.2, push_player, (choice, 845))
			gamethread.delayed(1.3, push_player, (choice, 980))
			gamethread.delayed(1.4, push_player, (choice, 1125))
			gamethread.delayed(1.5, push_player, (choice, 1280))
			gamethread.delayed(1.6, push_player, (choice, 1445))
			gamethread.delayed(1.7, push_player, (choice, 1620))
			gamethread.delayed(1.8, push_player, (choice, 1805))
			gamethread.delayed(1.9, push_player, (choice, 2000))

			gamethread.delayed(2.5, explosion, (choice))
			gamethread.delayed(2.5, kill_player, (choice))

			tokens["name"] = player.name
			tokens["target"] = target.name
			lang_msg("fireworks", tokens)
		else:
			es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

def give_dope(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		target = playerlib.getPlayer(choice)
		if target.isdead == 0:
			length = len(hurt_sounds) - 1
			sound = random.randint(0, length)
			player_sound(choice, hurt_sounds[sound], 1, 0.5)

			value = es.ServerVar("sm_referee_sound_give_dope")
			gamethread.delayed(1.5, player_sound, (choice, value, 1, 0.5))

			es.setplayerprop(choice, "CBasePlayer.m_iDefaultFOV", 155)

			player_shake(choice, 1, 100)
			gamethread.delayed(1.6, player_shake, (choice, 6.6, 25))

			gamethread.delayed(1.6, player_speed, (choice, 1.01))
			gamethread.delayed(1.7, player_speed, (choice, 1.02))
			gamethread.delayed(1.8, player_speed, (choice, 1.04))
			gamethread.delayed(2, player_speed, (choice, 1.08))
			gamethread.delayed(2.5, player_speed, (choice, 1.16))
			gamethread.delayed(3, player_speed, (choice, 1.32))
			gamethread.delayed(3.5, player_speed, (choice, 1.64))
			gamethread.delayed(4, player_speed, (choice, 2.28))
			gamethread.delayed(5, player_speed, (choice, 4.56))
			gamethread.delayed(7, player_speed, (choice, 9.68))

			cmd = "usermsg fade %s 1 500 500 255 255 255 200" % (choice)
			es.server.queuecmd(cmd)

			gamethread.delayed(2, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(2.2, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(2.4, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(2.6, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(2.8, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(3, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(3.2, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(3.4, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(3.6, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(3.8, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(4, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(4.2, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(4.4, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(4.6, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(4.8, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(5, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(5.2, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(5.4, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(5.6, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(5.8, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(6, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(6.2, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(6.4, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(6.6, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(6.8, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(7, player_fade, (choice, 2, 100, 100))
			gamethread.delayed(7.2, player_fade, (choice, 1, 100, 100))
			gamethread.delayed(7.4, player_fade, (choice, 2, 400, 400))

			gamethread.delayed(8.2, es.setplayerprop, (choice, "CBasePlayer.m_iDefaultFOV", 90))
			gamethread.delayed(8.2, kill_player, (choice))

			tokens["name"] = player.name
			tokens["target"] = target.name
			lang_msg("give_dope", tokens)
		else:
			es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

def out_breath(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		target = playerlib.getPlayer(choice)
		if target.isdead == 0:
			sound = es.ServerVar("sm_referee_sound_out_breath")
			player_sound(choice, sound, 1, 0.5)

			player_shake(choice, 6, 20)

			cmd = "usermsg fade %s 2 3000 2000 0 0 0 255" % (choice)
			es.server.queuecmd(cmd)

			gamethread.delayed(0.5, player_speed, (choice, 0.95))
			gamethread.delayed(1, player_speed, (choice, 0.9))
			gamethread.delayed(1.5, player_speed, (choice, 0.85))
			gamethread.delayed(2, player_speed, (choice, 0.8))
			gamethread.delayed(2.5, player_speed, (choice, 0.75))
			gamethread.delayed(3, player_speed, (choice, 0.7))
			gamethread.delayed(3.5, player_speed, (choice, 0.65))
			gamethread.delayed(4, player_speed, (choice, 0.6))
			gamethread.delayed(4.2, player_speed, (choice, 0.5))
			gamethread.delayed(4.4, player_speed, (choice, 0.4))
			gamethread.delayed(4.6, player_speed, (choice, 0.3))
			gamethread.delayed(4.8, player_speed, (choice, 0.2))
			gamethread.delayed(5, player_speed, (choice, 0.175))
			gamethread.delayed(5.2, player_speed, (choice, 0.15))
			gamethread.delayed(5.4, player_speed, (choice, 0.125))
			gamethread.delayed(5.6, player_speed, (choice, 0.1))
			gamethread.delayed(5.8, player_speed, (choice, 0.075))
			gamethread.delayed(6, player_speed, (choice, 0.05))
			gamethread.delayed(6.2, player_speed, (choice, 0.025))

			gamethread.delayed(6.2, kill_player, (choice))

			tokens["name"] = player.name
			tokens["target"] = target.name
			lang_msg("out_breath", tokens)
		else:
			es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

def lightning(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		target = playerlib.getPlayer(choice)
		if target.isdead == 0:
			sound = es.ServerVar("sm_referee_sound_lightning")
			player_sound(choice, sound, 1.0, 0.5)

			x,y,z = es.getplayerlocation(choice)
			pos1 = "%s,%s,%s" % (x, y, z)
			z += 2000
			pos2 = "%s,%s,%s" % (x, y, z)

			model = es.precachemodel("sprites/lgtning.vmt")

			cmd = "es_effect beam %s %s %s %s 0 30 0.1 5 5 0 0 255 255 255 255 100" % (pos1, pos2, model, model)
			es.server.queuecmd(cmd)

			x,y,z = es.getplayerlocation(choice)
			pos1 = "%s,%s,%s" % (x, y, z)
			pos2 = "0,0,0"
			cmd = "es_xeffect sparks %s 9999 3 %s" % (pos1, pos2)
			es.server.queuecmd(cmd)

			gamethread.delayed(0.1, kill_player, (choice))

			tokens["name"] = player.name
			tokens["target"] = target.name
			lang_msg("lightning", tokens)
		else:
			es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

def cheer_leader(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		target = playerlib.getPlayer(choice)
		if target.isdead == 0:
			if target.steamid not in cheer_leaders:
				cheer_leaders.append(target.steamid)

				es.give(choice, "player_weaponstrip")
				es.fire(choice, "player_weaponstrip", "strip")

				cmd = "playerset color %s 255 255 255 150" % (choice)
				es.server.queuecmd(cmd)

				es.setplayerprop(choice, "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

				tokens["name"] = player.name
				tokens["target"] = target.name
				lang_msg("cheer_leader", tokens)
			else:
				es.tell(userid, "#green", messages("already_cheer_leader", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def push_player(userid, push):
	myPlayer = playerlib.getPlayer(userid)
	isdead = myPlayer.isdead
	if isdead == 0:
		prop = "0,0,%s" % (push)
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", prop)

def explosion(userid):
	myPlayer = playerlib.getPlayer(userid)
	isdead = myPlayer.isdead
	if isdead == 0:
		es.emitsound("player", userid, "weapons/hegrenade/explode4.wav", "1.0", "0.5")
		x,y,z = es.getplayerlocation(userid)
		pos1 = "%s,%s,%s" % (x, y, z)
		pos2 = "0,0,0"
		cmd = "es_xeffect sparks %s 9999 3 %s" % (pos1, pos2)
		es.server.queuecmd(cmd)

def player_speed(userid, speed):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		player.setSpeed(speed)

def player_sound(userid, sound, volume, range):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		es.emitsound("player", userid, sound, volume, range)

def player_shake(userid, time, magnitude):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		cmd = "usermsg shake %s %s %s" % (userid, magnitude, time)
		es.server.queuecmd(cmd)

def player_fade(userid, style, time, total):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		random_red = random.randint(0, 255)
		random_green = random.randint(0, 255)
		random_blue = random.randint(0, 255)
		random_alpha = random.randint(100, 255)
		cmd = "usermsg fade %s %s %s %s %s %s %s %s" % (userid, style, time, total, random_red, random_green, random_blue, random_alpha)
		es.server.queuecmd(cmd)

def kill_player(userid):
	es.server.insertcmd("es_xsexec %s kill" % userid)

def create_player_menu(name, title, users, cancelmenu, block):
	if block == "fireworks":
		myPopup = popuplib.easymenu(name, None, fireworks)
	elif block == "give_dope":
		myPopup = popuplib.easymenu(name, None, give_dope)
	elif block == "out_breath":
		myPopup = popuplib.easymenu(name, None, out_breath)
	elif block == "lightning":
		myPopup = popuplib.easymenu(name, None, lightning)
	elif block == "cheer_leader":
		myPopup = popuplib.easymenu(name, None, cheer_leader)
	myPopup.settitle(title)

	myPlayerList = playerlib.getPlayerList(users)
	for player in myPlayerList:
		myPopup.addoption(player.userid, player.name)

	myPopup.submenu(10, cancelmenu)

def delete_keygroup():
	global cheer_leaders
	cheer_leaders = []

def delete_popup():
	if popuplib.exists("sm_popup_admin_referee_punish"):
		popuplib.delete("sm_popup_admin_referee_punish")

# ******************** Unload ********************
def unload():
	delete_keygroup()
	delete_popup()