﻿import es
import gamethread
import langlib
import playerlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/messages_referee_warn.ini")

# ******************** Load ********************
def load():
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Events ********************
def es_map_start(event_var):
	popuplib.delete("sm_popup_admin_referee_warn")
	create_popup()

def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "referee_custom_warning":
			if text != "!cancel":
				warn = text
				choice = es.keygetvalue("sm_keygroup_set", steamid, "userid")
				warning(userid, choice, warn)

			es.keydelete("sm_keygroup_set", steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/popup_admin_referee_warn.ini")

	popup = popuplib.create("sm_popup_admin_referee_warn")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	for i in range(1, 8):
		value = "sm_referee_warning_%s" % (i)
		warning = es.ServerVar(value)

		tokens = {}
		tokens['warning'] = warning
		line = "->%s. %s" % (i, text("warning", tokens))
		popup.addline(line)

	line = "->8. %s" % (text("custom"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, select_warning)
	popup.select(2, select_warning)
	popup.select(3, select_warning)
	popup.select(4, select_warning)
	popup.select(5, select_warning)
	popup.select(6, select_warning)
	popup.select(7, select_warning)
	popup.select(8, select_warning)
	popup.submenu(9, "sm_popup_admin_referee")

# ******************** Popup choices ********************
def select_warning(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if choice == 1:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_1")
	elif choice == 2:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_2")
	elif choice == 3:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_3")
	elif choice == 4:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_4")
	elif choice == 5:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_5")
	elif choice == 6:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_6")
	elif choice == 7:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_7")
	elif choice == 8:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "custom_warning")

	popuplib.send(name, userid)

# ******************** Player menu choices ********************
def warning_1(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_1")
	warning(userid, choice, warn)

def warning_2(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_2")
	warning(userid, choice, warn)

def warning_3(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_3")
	warning(userid, choice, warn)

def warning_4(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_4")
	warning(userid, choice, warn)

def warning_5(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_5")
	warning(userid, choice, warn)

def warning_6(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_6")
	warning(userid, choice, warn)

def warning_7(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_7")
	warning(userid, choice, warn)

def custom_warning(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		exists = es.exists("key", "sm_keygroup_set", player.steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", player.steamid)

		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "referee_custom_warning")
		es.keysetvalue("sm_keygroup_set", player.steamid, "userid", choice)

		es.tell(userid, "#green", messages("set_warning", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_referee_warn", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def warning(userid, choice, warn):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	exists = es.exists("userid", choice)
	if exists == 1:
		target = playerlib.getPlayer(choice)

		sound = es.ServerVar("sm_referee_sound_whistle")
		es.cexec_all("playgamesound", sound)

		tokens["name"] = player.name
		tokens["target"] = target.name
		tokens["warning"] = warn
		lang_msg("warn_message", tokens)

		es.menu(5, int(choice), messages("warning", tokens, target.get("lang")))

		es.centertell(choice, messages("warning", tokens, target.get("lang")))
		gamethread.delayed(1, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
		gamethread.delayed(2, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
		gamethread.delayed(3, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
		gamethread.delayed(4, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_warn", userid)

def create_player_menu(name, title, users, cancelmenu, block):
	if block == "warning_1":
		myPopup = popuplib.easymenu(name, None, warning_1)
	elif block == "warning_2":
		myPopup = popuplib.easymenu(name, None, warning_2)
	elif block == "warning_3":
		myPopup = popuplib.easymenu(name, None, warning_3)
	elif block == "warning_4":
		myPopup = popuplib.easymenu(name, None, warning_4)
	elif block == "warning_5":
		myPopup = popuplib.easymenu(name, None, warning_5)
	elif block == "warning_6":
		myPopup = popuplib.easymenu(name, None, warning_6)
	elif block == "warning_7":
		myPopup = popuplib.easymenu(name, None, warning_7)
	elif block == "custom_warning":
		myPopup = popuplib.easymenu(name, None, custom_warning)
	myPopup.settitle(title)

	myPlayerList = playerlib.getPlayerList(users)
	for player in myPlayerList:
		myPopup.addoption(player.userid, player.name)

	myPopup.submenu(10, cancelmenu)

# ******************** Unload ********************
def unload():
	es.addons.unregisterSayFilter(sayFilter)
	popuplib.delete("sm_popup_admin_referee_warn")