﻿import es
import langlib
import playerlib
import popuplib
import re

popup = popuplib.create("sm_popup_admin_settings_cap")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_cap.ini")
text_cap = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap_fights.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_cap.ini")

keygroup = {}

# ******************** Load ********************
def load():
	load_settings()
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_settings():
	value = es.keygetvalue("soccer_mod_settings", "cap", "weapon_1")
	es.set("sm_cap_weapon_1", value)

	value = es.keygetvalue("soccer_mod_settings", "cap", "weapon_2")
	es.set("sm_cap_weapon_2", value)

	value = es.keygetvalue("soccer_mod_settings", "cap", "weapon_3")
	es.set("sm_cap_weapon_3", value)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (texts("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_cap_weapon_1")
	line = "->1. %s #1: %s" % (texts("weapon"), value)
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_2")
	line = "->2. %s #2: %s" % (texts("weapon"), value)
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_3")
	line = "->3. %s #3: %s" % (texts("weapon"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, weapon)
	popup.select(2, weapon)
	popup.select(3, weapon)
	popup.submenu(4, "sm_popup_admin_settings_cap")
	popup.submenu(5, "sm_popup_admin_settings_cap")
	popup.submenu(6, "sm_popup_admin_settings_cap")
	popup.submenu(7, "sm_popup_admin_settings_cap")
	popup.submenu(8, "sm_popup_admin_settings_cap")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choices ********************
def weapon(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	value = "settings_cap_weapon_%s" % (choice)
	keygroup[steamid] = {'setting': value}

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_weapon_message", tokens, player.get("lang")))

# ******************** Events ********************
def es_map_start(event_var):
	global keygroup
	keygroup = {}

def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if steamid in keygroup:
		tokens = {}
		text = text.strip('"')
		player = playerlib.getPlayer(userid)

		type = keygroup[steamid]['setting']
		type_split = type.split("_")
		if type_split[0] == "settings" and type_split[1] == "cap" and type_split[2] == "weapon":
			number = int(type_split[3])
			if number > 0 and number < 4:
				if text != "!cancel":
					pattern = ".%s" % (text)
					check = re.search(pattern, ".ak47,aug,awp,deagle,elite,fiveseven,g3sg1,galil,glock,m249,m3,m4a1,mac10,mp5navy,p90,p228,scout,sg550,sg552,tmp,ump45,xm1014")
					if check != None:
						value = "sm_cap_weapon_%s" % (number)
						es.set(value, text)

						line = "->%s. %s #%s: %s" % (number, texts("weapon"), number, text)
						popup.modline((number + 2), line)

						tokens = {}
						tokens['weapon'] = text
						line = "->%s. %s" % (number, text_cap("weapon", tokens))
						popuplib.find("sm_popup_admin_cap_fights").modline((number + 4), line)

						name = es.getplayername(userid)
						tokens = {}
						tokens["name"] = name
						tokens["number"] = number
						tokens["weapon"] = text
						lang_msg("set_weapon", tokens)

						value = "weapon_%s" % (number)
						es.keysetvalue("soccer_mod_settings", "cap", value, text)
						es.keygroupsave("soccer_mod_settings", "soccer_mod")

						clear_key(userid, steamid)
					else:
						es.tell(userid, "#green", messages("invalid_weapon", tokens, player.get("lang")))
				else:
					clear_key(userid, steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	del keygroup[steamid]
	popuplib.send("sm_popup_admin_settings_cap", userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_cap")
	es.addons.unregisterSayFilter(sayFilter)