﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_main")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_main.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_match_main.ini")

# ******************** Load ********************
def load():
	load_settings()
	create_popup()

# ******************** Load variables ********************
def load_settings():
	value = int(es.keygetvalue("soccer_mod_settings", "match", "public_start_match"))
	es.set("sm_match_say_command_start_match_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "public_pause_match"))
	es.set("sm_match_say_command_pause_match_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "public_stop_match"))
	es.set("sm_match_say_command_stop_match_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "ready_vote"))
	es.set("sm_match_ready_vote_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "match_sounds"))
	es.set("sm_match_sounds_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "score_board"))
	es.set("sm_match_score_board_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "golden_goal"))
	es.set("sm_match_golden_goal_on", value)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_say_command_start_match_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->1. %s: %s" % (text("start match"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_say_command_pause_match_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->2. %s: %s" % (text("pause match"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_say_command_stop_match_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->3. %s: %s" % (text("stop match"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_ready_vote_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->4. %s: %s" % (text("ready vote"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_sounds_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->5. %s: %s" % (text("sounds"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_score_board_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->6. %s: %s" % (text("score board"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_golden_goal_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->7. %s: %s" % (text("golden goal"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, public_start_match)
	popup.select(2, public_pause_match)
	popup.select(3, public_stop_match)
	popup.select(4, ready_vote)
	popup.select(5, match_sounds)
	popup.select(6, score_board)
	popup.select(7, golden_goal)
	popup.submenu(8, "sm_popup_admin_settings_match_main")
	popup.submenu(9, "sm_popup_admin_settings_match")

# ******************** Popup choices ********************
def public_start_match(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_say_command_start_match_on")
	if value == 1:
		es.set("sm_match_say_command_start_match_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "public_start_match", 0)

		line = "->1. %s: %s" % (text("start match"), text("off"))
		popup.modline(3, line)

		lang_msg_on_off("set_public_start", tokens, "off")
	else:
		es.set("sm_match_say_command_start_match_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "public_start_match", 1)

		line = "->1. %s: %s" % (text("start match"), text("on"))
		popup.modline(3, line)

		lang_msg_on_off("set_public_start", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def public_pause_match(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_say_command_pause_match_on")
	if value == 1:
		es.set("sm_match_say_command_pause_match_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "public_pause_match", 0)

		line = "->2. %s: %s" % (text("pause match"), text("off"))
		popup.modline(4, line)

		lang_msg_on_off("set_public_pause", tokens, "off")
	else:
		es.set("sm_match_say_command_pause_match_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "public_pause_match", 1)

		line = "->2. %s: %s" % (text("pause match"), text("on"))
		popup.modline(4, line)

		lang_msg_on_off("set_public_pause", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def public_stop_match(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_say_command_stop_match_on")
	if value == 1:
		es.set("sm_match_say_command_stop_match_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "public_stop_match", 0)

		line = "->3. %s: %s" % (text("stop match"), text("off"))
		popup.modline(5, line)

		lang_msg_on_off("set_public_stop", tokens, "off")
	else:
		es.set("sm_match_say_command_stop_match_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "public_stop_match", 1)

		line = "->3. %s: %s" % (text("stop match"), text("on"))
		popup.modline(5, line)

		lang_msg_on_off("set_public_stop", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def ready_vote(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_ready_vote_on")
	if value == 1:
		es.set("sm_match_ready_vote_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "ready_vote", 0)

		line = "->4. %s: %s" % (text("ready vote"), text("off"))
		popup.modline(6, line)

		lang_msg_on_off("set_ready_vote", tokens, "off")
	else:
		es.set("sm_match_ready_vote_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "ready_vote", 1)

		line = "->4. %s: %s" % (text("ready vote"), text("on"))
		popup.modline(6, line)

		lang_msg_on_off("set_ready_vote", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def match_sounds(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_sounds_on")
	if value == 1:
		es.set("sm_match_sounds_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "match_sounds", 0)

		line = "->5. %s: %s" % (text("sounds"), text("off"))
		popup.modline(7, line)

		lang_msg_on_off("set_match_sounds", tokens, "off")
	else:
		es.set("sm_match_sounds_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "match_sounds", 1)

		line = "->5. %s: %s" % (text("sounds"), text("on"))
		popup.modline(7, line)

		lang_msg_on_off("set_match_sounds", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def score_board(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_score_board_on")
	if value == 1:
		es.set("sm_match_score_board_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "score_board", 0)

		line = "->6. %s: %s" % (text("score board"), text("off"))
		popup.modline(8, line)

		lang_msg_on_off("set_score_board", tokens, "off")
	else:
		es.set("sm_match_score_board_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "score_board", 1)

		line = "->6. %s: %s" % (text("score board"), text("on"))
		popup.modline(8, line)

		lang_msg_on_off("set_score_board", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def golden_goal(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_match_golden_goal_on")
	if value == 1:
		es.set("sm_match_golden_goal_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "golden_goal", 0)

		line = "->7. %s: %s" % (text("golden goal"), text("off"))
		popup.modline(9, line)

		lang_msg_on_off("set_golden_goal", tokens, "off")
	else:
		es.set("sm_match_golden_goal_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "golden_goal", 1)

		line = "->7. %s: %s" % (text("golden goal"), text("on"))
		popup.modline(9, line)

		lang_msg_on_off("set_golden_goal", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

# ******************** Functions ********************
def lang_msg_on_off(text, tokens, on_off):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		tokens["value"] = messages(on_off, tokens, player.get("lang"))
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_match_main"):
		popuplib.delete("sm_popup_admin_settings_match_main")

# ******************** Unload ********************
def unload():
	delete_popup()