﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_names")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_names.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_match_names.ini")

# ******************** Load ********************
def load():
	load_settings()
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_settings():
	value = es.keygetvalue("soccer_mod_settings", "match", "default_name_t")
	es.set("sm_match_default_name_t", value)

	value = es.keygetvalue("soccer_mod_settings", "match", "default_name_ct")
	es.set("sm_match_default_name_ct", value)

	value = es.keygetvalue("soccer_mod_settings", "match", "default_name_t_abbr")
	es.set("sm_match_default_name_t_abbr", value)

	value = es.keygetvalue("soccer_mod_settings", "match", "default_name_ct_abbr")
	es.set("sm_match_default_name_ct_abbr", value)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (texts("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_default_name_t")
	line = "->1. %s: %s" % (texts("name_t"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_default_name_ct")
	line = "->2. %s: %s" % (texts("name_ct"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_default_name_t_abbr")
	line = "->3. %s: %s" % (texts("short_name_t"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_default_name_ct_abbr")
	line = "->4. %s: %s" % (texts("short_name_ct"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, name_t)
	popup.select(2, name_ct)
	popup.select(3, short_name_t)
	popup.select(4, short_name_ct)
	popup.submenu(5, "sm_popup_admin_settings_match_names")
	popup.submenu(6, "sm_popup_admin_settings_match_names")
	popup.submenu(7, "sm_popup_admin_settings_match_names")
	popup.submenu(8, "sm_popup_admin_settings_match_names")
	popup.submenu(9, "sm_popup_admin_settings_match")

# ******************** Popup choices ********************
def name_t(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_name_t")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_t_message", tokens, player.get("lang")))

def name_ct(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_name_ct")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_ct_message", tokens, player.get("lang")))

def short_name_t(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_name_t_abbr")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_short_t_message", tokens, player.get("lang")))

def short_name_ct(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_name_ct_abbr")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_short_ct_message", tokens, player.get("lang")))

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_match_name_t":
			if text != "!cancel":
				es.set("sm_match_default_name_t", text)

				line = "->1. %s: %s" % (texts("name_t"), text)
				popup.modline(3, line)

				es.keysetvalue("soccer_mod_settings", "match", "default_name_t", text)
				es.keygroupsave("soccer_mod_settings", "soccer_mod")

				name = es.getplayername(userid)
				tokens = {}
				tokens["name"] = name
				tokens["value"] = text
				lang_msg("set_t", tokens)

				clear_key(userid, steamid)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_match_name_ct":
			if text != "!cancel":
				es.set("sm_match_default_name_ct", text)

				line = "->2. %s: %s" % (texts("name_ct"), text)
				popup.modline(4, line)

				es.keysetvalue("soccer_mod_settings", "match", "default_name_ct", text)
				es.keygroupsave("soccer_mod_settings", "soccer_mod")

				name = es.getplayername(userid)
				tokens = {}
				tokens["name"] = name
				tokens["value"] = text
				lang_msg("set_ct", tokens)

				clear_key(userid, steamid)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_match_name_t_abbr":
			if text != "!cancel":
				length = len(text)
				if length < 6:
					es.set("sm_match_default_name_t_abbr", text)

					line = "->3. %s: %s" % (texts("short_name_t"), text)
					popup.modline(5, line)

					es.keysetvalue("soccer_mod_settings", "match", "default_name_t_abbr", text)
					es.keygroupsave("soccer_mod_settings", "soccer_mod")

					name = es.getplayername(userid)
					tokens = {}
					tokens["name"] = name
					tokens["value"] = text
					lang_msg("set_short_t", tokens)

					clear_key(userid, steamid)
				else:
					es.tell(userid, "#green", messages("to_long", tokens, player.get("lang")))
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_match_name_ct_abbr":
			if text != "!cancel":
				length = len(text)
				if length < 6:
					es.set("sm_match_default_name_ct_abbr", text)

					line = "->4. %s: %s" % (texts("short_name_ct"), text)
					popup.modline(6, line)

					es.keysetvalue("soccer_mod_settings", "match", "default_name_ct_abbr", text)
					es.keygroupsave("soccer_mod_settings", "soccer_mod")

					name = es.getplayername(userid)
					tokens = {}
					tokens["name"] = name
					tokens["value"] = text
					lang_msg("set_short_ct", tokens)

					clear_key(userid, steamid)
				else:
					es.tell(userid, "#green", messages("to_long", tokens, player.get("lang")))
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_match_names", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_match_names"):
		popuplib.delete("sm_popup_admin_settings_match_names")

# ******************** Unload ********************
def unload():
	delete_popup()
	es.addons.unregisterSayFilter(sayFilter)