﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_time")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_time.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_match_time.ini")

# ******************** Load ********************
def load():
	load_settings()
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_settings():
	value = int(es.keygetvalue("soccer_mod_settings", "match", "periods"))
	es.set("sm_match_number_periods", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "restart_length"))
	es.set("sm_match_restart_length", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "period_length"))
	es.set("sm_match_period_length", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "period_break_length"))
	es.set("sm_match_period_break_length", value)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (texts("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_number_periods")
	line = "->1. %s: %s" % (texts("periods"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_restart_length")
	line = "->2. %s: %s" % (texts("restart_length"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_period_length")
	line = "->3. %s: %s" % (texts("period_length"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_period_break_length")
	line = "->4. %s: %s" % (texts("period_break_length"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, periods)
	popup.select(2, restart_length)
	popup.select(3, period_length)
	popup.select(4, period_break_length)
	popup.submenu(5, "sm_popup_admin_settings_match_time")
	popup.submenu(6, "sm_popup_admin_settings_match_time")
	popup.submenu(7, "sm_popup_admin_settings_match_time")
	popup.submenu(8, "sm_popup_admin_settings_match_time")
	popup.submenu(9, "sm_popup_admin_settings_match")

# ******************** Popup choices ********************
def periods(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_periods")

		es.tell(userid, "#green", messages("set_periods_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_time_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def restart_length(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_restart_length")

		es.tell(userid, "#green", messages("set_restart_length_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_time_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def period_length(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_period_length")

		es.tell(userid, "#green", messages("set_period_length_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_time_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def period_break_length(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_period_break_length")

		es.tell(userid, "#green", messages("set_period_break_length_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_time_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_settings_match_time", userid)

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_match_time_periods":
			if text != "!cancel":
				error = messages("set_periods_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10:
							es.set("sm_match_number_periods", value)

							line = "->1. %s: %s" % (texts("periods"), value)
							popup.modline(3, line)

							es.keysetvalue("soccer_mod_settings", "match", "periods", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_periods", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_match_time_restart_length":
			if text != "!cancel":
				error = messages("set_restart_length_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 60:
							es.set("sm_match_restart_length", value)

							line = "->2. %s: %s" % (texts("restart_length"), value)
							popup.modline(4, line)

							es.keysetvalue("soccer_mod_settings", "match", "restart_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_restart_length", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_match_time_period_length":
			if text != "!cancel":
				error = messages("set_period_length_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10000:
							es.set("sm_match_period_length", value)

							line = "->3. %s: %s" % (texts("period_length"), value)
							popup.modline(5, line)

							es.keysetvalue("soccer_mod_settings", "match", "period_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_period_length", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_match_time_period_break_length":
			if text != "!cancel":
				error = messages("set_period_break_length_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10000:
							es.set("sm_match_period_break_length", value)

							line = "->4. %s: %s" % (texts("period_break_length"), value)
							popup.modline(6, line)

							es.keysetvalue("soccer_mod_settings", "match", "period_break_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_period_break_length", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_match_time", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_match_time"):
		popuplib.delete("sm_popup_admin_settings_match_time")

# ******************** Unload ********************
def unload():
	delete_popup()
	es.addons.unregisterSayFilter(sayFilter)