﻿import es
import langlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

# ******************** Load ********************
def load():
	es.keygroupload("soccer_mod_settings", "soccer_mod")

	create_popup()

	enabled = es.ServerVar("sm_module_cap_on")
	if enabled == 1:
		es.load("soccer_mod_2010/settings/cap")

		enabled = es.ServerVar("sm_module_match_on")
	if enabled == 1:
		es.load("soccer_mod_2010/settings/match")

	enabled = es.ServerVar("sm_module_player_on")
	if enabled == 1:
		es.load("soccer_mod_2010/settings/player")

	enabled = es.ServerVar("sm_module_sprint_on")
	if enabled == 1:
		es.load("soccer_mod_2010/settings/sprint")

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings.ini")

	popup = popuplib.create("sm_popup_admin_settings")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	number = 0

	enabled = es.ServerVar("sm_module_cap_on")
	if enabled == 1:
		number += 1
		temp_string = "->%s. %s" % (number, text("cap"))
		popup.addline(temp_string)
		popup.submenu(number, "sm_popup_admin_settings_cap")

	enabled = es.ServerVar("sm_module_match_on")
	if enabled == 1:
		number += 1
		temp_string = "->%s. %s" % (number, text("match"))
		popup.addline(temp_string)
		popup.submenu(number, "sm_popup_admin_settings_match")

	enabled = es.ServerVar("sm_module_player_on")
	if enabled == 1:
		number += 1
		temp_string = "->%s. %s" % (number, text("player"))
		popup.addline(temp_string)
		popup.submenu(number, "sm_popup_admin_settings_player")

	enabled = es.ServerVar("sm_module_sprint_on")
	if enabled == 1:
		number += 1
		temp_string = "->%s. %s" % (number, text("sprint"))
		popup.addline(temp_string)
		popup.submenu(number, "sm_popup_admin_settings_sprint")

	if number == 0:
		popup.addline(text("none"))

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	number += 1
	while number < 9:
		popup.submenu(number, "sm_popup_admin_settings")
		number += 1

	popup.submenu(9, "sm_popup_admin")

# ******************** Unload ********************
def unload():
	es.keygroupdelete("soccer_mod_settings")
	popuplib.delete("sm_popup_admin_settings")

	enabled = es.ServerVar("sm_module_cap_on")
	if enabled == 1:
		es.unload("soccer_mod_2010/settings/cap")

	enabled = es.ServerVar("sm_module_match_on")
	if enabled == 1:
		es.unload("soccer_mod_2010/settings/match")

	enabled = es.ServerVar("sm_module_player_on")
	if enabled == 1:
		es.unload("soccer_mod_2010/settings/player")

	enabled = es.ServerVar("sm_module_sprint_on")
	if enabled == 1:
		es.unload("soccer_mod_2010/settings/sprint")