﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_sprint")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_sprint.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_sprint.ini")

# ******************** Load ********************
def load():
	load_settings()
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_settings():
	value = float(es.keygetvalue("soccer_mod_settings", "sprint", "speed"))
	es.set("sm_sprint_speed", value)

	value = int(es.keygetvalue("soccer_mod_settings", "sprint", "length"))
	es.set("sm_sprint_length", value)

	value = int(es.keygetvalue("soccer_mod_settings", "sprint", "reset"))
	es.set("sm_sprint_reset", value)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (texts("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_sprint_speed")
	line = "->1. %s: %s" % (texts("speed"), value)
	popup.addline(line)

	value = es.ServerVar("sm_sprint_length")
	line = "->2. %s: %s" % (texts("length"), value)
	popup.addline(line)

	value = es.ServerVar("sm_sprint_reset")
	line = "->3. %s: %s" % (texts("reset"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, speed)
	popup.select(2, length)
	popup.select(3, reset)
	popup.submenu(4, "sm_popup_admin_settings_sprint")
	popup.submenu(5, "sm_popup_admin_settings_sprint")
	popup.submenu(6, "sm_popup_admin_settings_sprint")
	popup.submenu(7, "sm_popup_admin_settings_sprint")
	popup.submenu(8, "sm_popup_admin_settings_sprint")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choices ********************
def speed(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_sprint_speed")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_sprint_speed_message", tokens, player.get("lang")))

def length(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_sprint_length")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_sprint_length_message", tokens, player.get("lang")))

def reset(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_sprint_reset")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_sprint_reset_length_message", tokens, player.get("lang")))

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_sprint_speed":
			if text != "!cancel":
				error = messages("set_sprint_speed_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = round(temp_value, 2)
					if value >= 1:
						if value <= 10:
							es.set("sm_sprint_speed", value)

							line = "->1. %s: %s" % (texts("speed"), value)
							popup.modline(3, line)

							es.keysetvalue("soccer_mod_settings", "sprint", "speed", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_sprint_speed", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_sprint_length":
			if text != "!cancel":
				error = messages("set_sprint_length_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10:
							es.set("sm_sprint_length", value)

							line = "->2. %s: %s" % (texts("length"), value)
							popup.modline(4, line)

							es.keysetvalue("soccer_mod_settings", "sprint", "length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_sprint_length", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		elif type == "settings_sprint_reset":
			if text != "!cancel":
				error = messages("set_sprint_reset_length_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 100:
							es.set("sm_sprint_reset", value)

							line = "->3. %s: %s" % (texts("reset"), value)
							popup.modline(5, line)

							es.keysetvalue("soccer_mod_settings", "sprint", "reset", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_sprint_reset_length", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_sprint", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_sprint"):
		popuplib.delete("sm_popup_admin_settings_sprint")

# ******************** Unload ********************
def unload():
	delete_popup()
	es.addons.unregisterSayFilter(sayFilter)