﻿# SOCCER MOD 2010
#
# CREDITS:
#
# SCRIPT:
# - FCD | Cor Lems
# - FCD | Marco Boogers
#
# SKINS:
# - FCD | Termi
#
# TRAINING BALL MODEL:
# - FCD | Marco Boogers
#
# FOR THE LATEST VERSION OF SOCCER MOD GO TO:
# http://addons.eventscripts.com/addons/view/soccer_mod_2010
#
# *************************************************************************
# *************************************************************************
# DO NOT EDIT THIS FILE OR ANY OTHER FILE IN ONE OF THE SUBDIRECTORIES!!!!!
# GO TO cstrike/cfg/soccer_mod TO CHANGE SETTINGS!!!!!
# *************************************************************************
# *************************************************************************

import es
import langlib
import os
import playerlib

required = [
	"cfg",
	"downloads",
	"cmd",
	"admin",
	"info",
	"settings",
	"vote"
]

modules = [
	"cap",
	"match",
	"player",
	"referee",
	"shout",
	"sprint",
	"training"
]

files = [
	"downloads.cfg",
	"es_soccer_mod_admins_db.txt",
	"es_soccer_mod_maps_db.txt",
	"es_soccer_mod_settings_db.txt",
	"ranking.db",
	"soccer_mod.cfg"
]

files_modules = [
	"cap.cfg",
	"match.cfg",
	"player.cfg",
	"referee.cfg",
	"shout.cfg",
	"sprint.cfg",
	"training.cfg"
]

messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/messages.ini")

# ******************** Load ********************
def load():
	es.set("soccer_mod_2010_version", 1.05)
	es.makepublic("soccer_mod_2010_version")

	path = "cstrike/cfg/soccer_mod/"
	list = os.listdir(path)
	for item in list:
		if item not in files:
			try:
				os.remove(path + str(item))
			except OSError:
				error = 1

	path = "cstrike/cfg/soccer_mod/modules/"
	list = os.listdir(path)
	for item in list:
		if item not in files_modules:
			try:
				os.remove(path + str(item))
			except OSError:
				error = 1

	for row in required:
		cmd = "soccer_mod_2010/%s" % (row)
		es.load(cmd)

	for row in modules:
		value = "sm_module_%s_on" % (row)
		check = es.ServerVar(value)
		if check == 1:
			cmd = "soccer_mod_2010/%s" % (row)
			es.load(cmd)

	es.msg("#green", "Soccer Mod 2010 loaded.")

# ******************** Events ********************
def player_activate(event_var):
	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		tokens = {}
		player = playerlib.getPlayer(event_var["userid"])

		tokens["mod"] = "SOCCER MOD 2010"
		message = str(messages("uses_soccer_mod", tokens, player.get("lang"))) + "\n"

		message += " \n"

		cmd = es.ServerVar("sm_cmd_info")
		tokens["command"] = cmd
		message += str(messages("info", tokens, player.get("lang")))

		es.menu(10, int(event_var["userid"]), message)

# ******************** Unload ********************
def unload():
	for row in required:
		cmd = "soccer_mod_2010/%s" % (row)
		es.unload(cmd)

	for row in modules:
		value = "sm_module_%s_on" % (row)
		check = es.ServerVar(value)
		if check == 1:
			cmd = "soccer_mod_2010/%s" % (row)
			es.unload(cmd)

	es.msg("#green", "Soccer Mod 2010 unloaded.")