﻿import es
import gamethread
import langlib
import playerlib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/sprint/messages.ini")

used = []

# ******************** Commands ********************
def cmd_sprint():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		if player.steamid not in used:
			used.append(player.steamid)

			value = es.ServerVar("sm_sprint_speed")
			player.setSpeed(value)

			es.tell(userid, "#green", messages("use", tokens, player.get("lang")))

			value = es.ServerVar("sm_sprint_length")
			gamethread.delayed(value, stop, (userid))

			value = es.ServerVar("sm_sprint_reset")
			gamethread.delayed(value, reset, (userid, player.steamid))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def stop(userid):
	exists = es.exists("userid", userid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		player.setSpeed(1)

		es.tell(userid, "#green", messages("end", tokens, player.get("lang")))

def reset(userid, steamid):
	used.remove(steamid)

	exists = es.exists("userid", userid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		es.tell(userid, "#green", messages("reset", tokens, player.get("lang")))