﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random
import repeat
import vecmath

popup = popuplib.create("sm_popup_admin_training_cannon")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/training/messages_training_cannon.ini")
texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/training/popup_admin_training_cannon.ini")

# ******************** Load ********************
def load():
	load_variables()
	create_popup()
	sm_training_cannon = repeat.create("cannon", shoot, ())
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_variables():
	es.set("sm_training_cannon_on", 0)
	es.set("sm_training_randomness", 1)
	es.set("sm_training_fire_rate", 2.5)
	es.set("sm_training_height", 1)
	es.set("sm_training_power", 10000)

# ******************** Events ********************
def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		entity = es.getentityindex("func_physbox")
		es.set("sm_training_ballid", entity)

def player_disconnect(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		myPlayerList = playerlib.getPlayerList("#human")
		length = len(myPlayerList)
		if length < 1:
			sm_training_cannon = repeat.find("cannon")

			check = sm_training_cannon.status()
			if check > 1:
				sm_training_cannon.stop()

def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "training_randomness":
			if text != "!cancel":
				error = messages("set_randomness_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 500:
							es.set("sm_training_randomness", value)

							line = "->5. %s: %s" % (texts("randomness"), value)
							popup.modline(7, line)

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_randomness", tokens)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", userid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", userid)
			return (0, None, 0)
		elif type == "training_fire_rate":
			if text != "!cancel":
				error = messages("set_fire_rate_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = round(temp_value, 1)
					if value >= 0.5:
						if value <= 10:
							es.set("sm_training_fire_rate", value)

							line = "->6. %s: %s" % (texts("fire_rate"), value)
							popup.modline(8, line)

							sm_training_cannon = repeat.find("cannon")

							check = sm_training_cannon.status()
							if check > 1:
								sm_training_cannon.stop()
								es.set("sm_training_first_shot", 1)
								shoot()

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_fire_rate", tokens)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", userid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", userid)
			return (0, None, 0)
		elif type == "training_height":
			if text != "!cancel":
				error = messages("set_height_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 500:
							es.set("sm_training_height", value)

							line = "->7. %s: %s" % (texts("height"), value)
							popup.modline(9, line)

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_height", tokens)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", userid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", userid)
			return (0, None, 0)
		elif type == "training_power":
			if text != "!cancel":
				error = messages("set_power_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = round(temp_value, 3)
					if value >= 0.001:
						if value <= 10000:
							es.set("sm_training_power", value)

							line = "->8. %s: %s" % (texts("power"), value)
							popup.modline(10, line)

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_power", tokens)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", userid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", userid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (texts("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (texts("position"))
	popup.addline(line)

	line = "->2. %s" % (texts("aim"))
	popup.addline(line)

	line = "->3. %s" % (texts("on"))
	popup.addline(line)

	line = "->4. %s" % (texts("off"))
	popup.addline(line)

	value = es.ServerVar("sm_training_randomness")
	line = "->5. %s: %s" % (texts("randomness"), value)
	popup.addline(line)

	value = es.ServerVar("sm_training_fire_rate")
	line = "->6. %s: %s" % (texts("fire_rate"), value)
	popup.addline(line)

	value = es.ServerVar("sm_training_height")
	line = "->7. %s: %s" % (texts("height"), value)
	popup.addline(line)

	value = es.ServerVar("sm_training_power")
	line = "->8. %s: %s" % (texts("power"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, position)
	popup.select(2, aim_position)
	popup.select(3, cannon_on)
	popup.select(4, cannon_off)
	popup.select(5, set_randomness)
	popup.select(6, set_fire_rate)
	popup.select(7, set_height)
	popup.select(8, set_power)
	popup.submenu(9, "sm_popup_admin_training")

# ******************** Popup choices ********************
def position(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		es.set("cannon_x", 0)
		es.set("cannon_y", 0)
		es.set("cannon_z", 0)

		cmd = "playerget viewcoord %s cannon_x cannon_y cannon_z" % (userid)
		es.server.queuecmd(cmd)

		gamethread.delayed(0.01, show_position)

		name = es.getplayername(userid)
		tokens = {}
		tokens["name"] = name
		lang_msg("position", tokens)
	else:
		es.tell(userid, "#green", messages("no_postion_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training_cannon", userid)

def aim_position(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		es.set("cannon_aim_x", 0)
		es.set("cannon_aim_y", 0)
		es.set("cannon_aim_z", 0)

		cmd = "playerget viewcoord %s cannon_aim_x cannon_aim_y cannon_aim_z" % (userid)
		es.server.queuecmd(cmd)

		gamethread.delayed(0.01, show_aim_position)

		name = es.getplayername(userid)
		tokens = {}
		tokens["name"] = name
		lang_msg("aim_position", tokens)
	else:
		es.tell(userid, "#green", messages("no_aim_postion_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training_cannon", userid)

def cannon_on(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("sm_training_ballid")
		if check > 0:
			sm_training_cannon = repeat.find("cannon")

			check = sm_training_cannon.status()
			if check == 1:
				delay = float(es.ServerVar("sm_training_fire_rate"))
				sm_training_cannon.start(delay, 0)

				es.set("sm_training_first_shot", 1)
				es.set("sm_training_cannon_on", 1)

				shoot()

				name = es.getplayername(userid)
				tokens = {}
				tokens["name"] = name
				lang_msg("on", tokens)
			else:
				es.tell(userid, "#green", messages("already_on", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("no_ball", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_on_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training_cannon", userid)

def cannon_off(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	sm_training_cannon = repeat.find("cannon")

	check = sm_training_cannon.status()
	if check > 1:
		sm_training_cannon.stop()

		es.set("sm_training_cannon_on", 0)

		name = es.getplayername(userid)
		tokens = {}
		tokens["name"] = name
		lang_msg("off", tokens)
	else:
		es.tell(userid, "#green", messages("already_off", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training_cannon", userid)

def set_randomness(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_randomness")

		es.tell(userid, "#green", messages("set_randomness_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_settings_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_training_cannon", userid)

def set_fire_rate(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_fire_rate")

		es.tell(userid, "#green", messages("set_fire_rate_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_settings_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_training_cannon", userid)

def set_height(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_height")

		es.tell(userid, "#green", messages("set_height_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_settings_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_training_cannon", userid)

def set_power(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_power")

		es.tell(userid, "#green", messages("set_power_message", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_settings_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_training_cannon", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def show_position():
	x = es.ServerVar("cannon_x")
	y = es.ServerVar("cannon_y")
	z = es.ServerVar("cannon_z")
	show_lines(x, y, z)

def show_aim_position():
	x = es.ServerVar("cannon_aim_x")
	y = es.ServerVar("cannon_aim_y")
	z = es.ServerVar("cannon_aim_z")
	show_lines(x, y, z)

def show_lines(x, y, z):
	model = es.precachemodel("sprites/crystal_beam1.vmt")

	pos1 = "%s,%s,%s" % ((x - 25), y, z)
	pos2 = "%s,%s,%s" % ((x + 25), y, z)

	cmd = "es_effect beam %s %s %s %s 0 0 5 5 5 0 1 255 0 0 255 5" % (pos1, pos2, model, model)
	es.server.queuecmd(cmd)

	pos1 = "%s,%s,%s" % (x, (y - 25), z)
	pos2 = "%s,%s,%s" % (x, (y + 25), z)

	cmd = "es_effect beam %s %s %s %s 0 0 5 5 5 0 1 255 0 0 255 5" % (pos1, pos2, model, model)
	es.server.queuecmd(cmd)

	pos1 = "%s,%s,%s" % (x, y, (z - 25))
	pos2 = "%s,%s,%s" % (x, y, (z + 25))

	cmd = "es_effect beam %s %s %s %s 0 0 5 5 5 0 1 255 0 0 255 5" % (pos1, pos2, model, model)
	es.server.queuecmd(cmd)

def shoot():
	ballid = es.ServerVar("sm_training_ballid")
	x = es.ServerVar("cannon_x")
	y = es.ServerVar("cannon_y")
	z = es.ServerVar("cannon_z")
	value = es.ServerVar("sm_training_height")
	height = int(value)
	z += 15
	z += height

	players = es.getUseridList()
	length = len(players)
	if length > 0:
		length -= 1
		value = random.randint(0, length)
		userid = players[value]

		cmd = 'es_xfire %s func_physbox wake' % (userid)
		es.server.queuecmd(cmd)

	cmd = "es_xphysics active teleport %s %s,%s,%s" % (ballid, x, y, z)
	es.server.queuecmd(cmd)
	gamethread.delayed(0.1, push)

	check = es.ServerVar("sm_training_first_shot")
	if check == 1:
		es.set("sm_training_first_shot", 0)

		sm_training_cannon = repeat.find("cannon")

		check = sm_training_cannon.status()
		if check == 1:
			delay = float(es.ServerVar("sm_training_fire_rate"))
			sm_training_cannon.start(delay, 0)

def push():
	ballid = es.ServerVar("sm_training_ballid")

	x = es.ServerVar("cannon_aim_x")
	y = es.ServerVar("cannon_aim_y")
	z = es.ServerVar("cannon_aim_z")
	randomness = int(es.ServerVar("sm_training_randomness"))
	if randomness > 0:
		x_min = x
		x_min -= randomness

		x_max = x
		x_max += randomness

		x = random.uniform(x_min, x_max)

		y_min = y
		y_min -= randomness

		y_max = y
		y_max += randomness

		y = random.uniform(y_min, y_max)

		z_min = z
		z_min -= randomness

		z_max = z
		z_max += randomness

		z = random.uniform(z_min, z_max)

	vector1 = vecmath.vector([x, y, z])

	x = es.ServerVar("cannon_x")
	y = es.ServerVar("cannon_y")
	z = es.ServerVar("cannon_z")
	vector2 = vecmath.vector([x, y, z])

	power = float(es.ServerVar("sm_training_power"))
	push_vector = (vector1 - vector2) * power
	es.set("sm_training_cannon_aim", push_vector)

	vector = es.ServerVar("sm_training_cannon_aim")
	cmd = "es_xphysics active setvelocity %s %s" % (ballid, vector)
	es.server.queuecmd(cmd)

def delete_popup():
	if popuplib.exists("sm_popup_admin_training_cannon"):
		popuplib.delete("sm_popup_admin_training_cannon")

# ******************** Unload ********************
def unload():
	repeat.delete("cannon")

	delete_popup()
	es.addons.unregisterSayFilter(sayFilter)